///////////////////////////////////////
// Logic Analyzer test
// Test with video
// compile with
// 
///////////////////////////////////////
//=======================================================
// Logic analyser
//=======================================================
// check for trigger
// -- if triggered log data to memory
// -- signal HPS
//
// write the controller memory 
// Bus address 0xC0000000
// -- addr 0 -- new data? yes==1
// -- addr 1 -- allow capture to occur -- arm 
// -- addr 2 -- trigger count (after trigger event)
// write trigger mask -- two 32 bit words 
// -- addr 254 dont care mask a "1" means "care"
// -- addr 255 actual bits
// read the controller memory
// -- addr 250 -- data capture complete == 1
// -- addr 251 -- addr_complete (sram addr of trigger sample)
// 
// Read the alanyzer buffer
// Bus address 0xC0001000
// read 1000 words starting at offset "addr_complete"
// and wrapping at 12 bits

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/ipc.h> 
#include <sys/shm.h> 
#include <sys/mman.h>
#include <sys/time.h> 
#include <math.h> 

#include "address_map_arm_brl4.h"


// ==========================================
// h2f_axi_master; scratch RAM at 0xC0000000
// analyzer buffer at 0xC0001000
// analyzer control at 0xC0000000
// Change THESE if you move the SRAM in Qsys
#define FPGA_SRAM_BASE      0xC8000000
#define FPGA_SRAM_SPAN      0x00008000
#define M10K_OFFSET         0x00004000
// ==========================================
/// lw_bus 
#define HW_REGS_BASE          0xff200000
#define HW_REGS_SPAN          0x00005000 

// ==========================================
	
// the light weight buss base
void *h2p_lw_virtual_base;

// HPS_to_FPGA FIFO write address
// main bus addess 0x0000_0000
signed int* M10K_ptr = NULL;
void *h2p_virtual_base;
// RAM FPGA command buffer
int fd;
int main(void)
{

	// Declare volatile pointers to I/O registers (volatile 	
	// means that IO load and store instructions will be used 	
	// to access these pointer locations, 
	// instead of regular memory loads and stores)  
  
	// === get FPGA addresses ==================
    // Open /dev/mem
	if( ( fd = open( "/dev/mem", ( O_RDWR | O_SYNC ) ) ) == -1 ) 	{
		printf( "ERROR: could not open \"/dev/mem\"...\n" );
		return( 1 );
	}
    
	//============================================
    // get virtual addr that maps to physical
	// for light weight bus
	// FIFO status registers
	h2p_lw_virtual_base = mmap( NULL, HW_REGS_SPAN, ( PROT_READ | PROT_WRITE ), MAP_SHARED, fd, HW_REGS_BASE );	
	if( h2p_lw_virtual_base == MAP_FAILED ) {
		printf( "ERROR: mmap1() failed...\n" );
		close( fd );
		return(1);
	}
	
	//============================================
	
	//  RAM FPGA parameter/analyzer addrs 
	h2p_virtual_base = mmap( NULL, FPGA_SRAM_SPAN, ( PROT_READ | PROT_WRITE ), MAP_SHARED, fd, FPGA_SRAM_BASE); 	
	
	if( h2p_virtual_base == MAP_FAILED ) {
		printf( "ERROR: mmap3() failed...\n" );
		close( fd );
		return(1);
	}
    // Get the address that maps to the RAM buffers
	M10K_ptr =(unsigned int *)(h2p_virtual_base + M10K_OFFSET);
    int readdata;
    int writedata = 0xffff;

	while(1) 
	{

        printf("Writing to M10K block Addr 3\n");
        *(M10K_ptr + 3) = writedata;

        // printf("Reading from Addr 0\n");
        // readdata = *(M10K_ptr);
        // printf("Read %d from M10K\n", readdata);

        printf("Reading from Addr 3\n");
        readdata = *(M10K_ptr + 3);
        printf("Read %d from M10K\n", readdata);

        usleep(100);



	} // end while(1)
} // end main
